%define prefix %{_prefix}/kerberos
%define xinetd 0

Summary: Kerberos Authentication System
Name: krb5
Version: 1.1.1
Release: 25
Source0: krb5-%{version}.src.tar.gz
Source1: krb5-%{version}.crypto.tar.gz
Source2: krb5-%{version}.doc.tar.gz
Source3: kpropd.init
Source4: krb524d.init
Source5: kadmind.init
Source6: krb5kdc.init
Source7: krb5.conf
Source8: krb5.sh
Source9: krb5.csh
Source10: kdcrotate
Source11: kdc.conf
Source12: kadm5.acl
Source13: krsh
Source14: krlogin
Source15: eklogin.xinetd
Source16: klogin.xinetd
Source17: kshell.xinetd
Source18: krb5-telnet.xinetd
Source19: gssftp.xinetd
Source20: krb5server.init
Patch0:  krb5-1.1-krb4.patch
Patch1:  krb5-1.1-db.patch
Patch2:  krb5-1.1.1-tiocgltc.patch
Patch3:  krb5-1.1.1-libpty.patch
Patch4:  krb5-1.1.1-fixinfo.patch
Patch5:  krb5-1.1.1-manpages.patch
Patch6:  krb5-1.1.1-formatstring.patch
Patch7:  krb5-1.1.1-netkitr.patch
Patch8:  krb5-1.1.1-rlogind.patch
Patch9:  krb5-1.2-ksu.patch
Patch10: krb5-1.2-ksu.options.patch
Patch11: krb5-1.2-ksu.man.patch
Patch12: krb5-1.1.1-bufferparanoia.patch
Patch13: krb5-1.1.1-schiller.patch
Patch14: krb5-1.1.1-doublefree.patch
Patch15: krb5-1.1.1-schiller2.patch
Patch16: krb5-1.1.1-raeburn.patch
Patch17: krb5-1.1.1-quiet.patch
Patch18: krb5-1.1.1-yu.patch
Patch19: krb5-1.1.1-brokenrev.patch
Patch20: krb5-1.1.1-gssftp.patch
Patch21: krb5-1.2.1-forward.patch
Patch22: krb5-1.2.1-heap.patch
Copyright: MIT, freely distributable.
URL: http://web.mit.edu/kerberos/www/
Group: System Environment/Libraries
BuildRoot: %{_tmppath}/%{name}-root
Prereq: grep info sh-utils /sbin/install-info
BuildPrereq: e2fsprogs-devel, rsh, tcl, texinfo

%description
Kerberos is a trusted-third-party authentication system, named for the
three-headed watchdog from Greek mythology who guarded the entrance to
the underworld.

%changelog
* Tue Sep 12 2000 Nalin Dahyabhai <nalin@redhat.com>
- backport fix for problems in klogind credential forwarding (#11588)
- backport fix for heap corruption in ftp client (#14301)

* Mon Jun 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- only remove old krb5server init script links if the init script is there

* Sat Jun 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- disable kshell and eklogin by default

* Thu Jun 15 2000 Nalin Dahyabhai <nalin@redhat.com>
- patch mkdir/rmdir problem in ftpcmd.y
- add condrestart option to init script
- split the server init script into three pieces and add one for kpropd

* Wed Jun 14 2000 Nalin Dahyabhai <nalin@redhat.com>
- make sure workstation servers are all disabled by default
- clean up krb5server init script

* Fri Jun  9 2000 Nalin Dahyabhai <nalin@redhat.com>
- apply second set of buffer overflow fixes from Tom Yu
- fix from Dirk Husung for a bug in buffer cleanups in the test suite
- work around possibly broken rev binary in running test suite
- move default realm configs from /var/kerberos to %{_var}/kerberos

* Tue Jun  6 2000 Nalin Dahyabhai <nalin@redhat.com>
- make ksu and v4rcp owned by root

* Sat Jun  3 2000 Nalin Dahyabhai <nalin@redhat.com>
- use %%{_infodir} to better comply with FHS
- move .so files to -devel subpackage
- tweak xinetd config files (bugs #11833, #11835, #11836, #11840)
- fix package descriptions again

* Wed May 24 2000 Nalin Dahyabhai <nalin@redhat.com>
- change a LINE_MAX to 1024, fix from Ken Raeburn
- add fix for login vulnerability in case anyone rebuilds without krb4 compat
- add tweaks for byte-swapping macros in krb.h, also from Ken
- add xinetd config files
- make rsh and rlogin quieter
- build with debug to fix credential forwarding
- add rsh as a build-time req because the configure scripts look for it to
  determine paths

* Wed May 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix config_subpackage logic

* Tue May 16 2000 Nalin Dahyabhai <nalin@redhat.com>
- remove setuid bit on v4rcp and ksu
- apply patches from Jeffrey Schiller to fix overruns Chris Evans found
- reintroduce configs subpackage for use in the errata
- add PreReq: sh-utils

* Mon May 15 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix double-free in the kdc (patch merged into MIT tree)
- include convert-config-files script as a documentation file

* Wed May 03 2000 Nalin Dahyabhai <nalin@redhat.com>
- patch ksu man page because the -C option never works
- add access() checks and disable debug mode in ksu
- modify default ksu build arguments to specify more directories in CMD_PATH
  and to use getusershell()

* Wed May 03 2000 Bill Nottingham <notting@redhat.com>
- fix configure stuff for ia64

* Mon Apr 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- add LDCOMBINE=-lc to configure invocation to use libc versioning (bug #10653)
- change Requires: for/in subpackages to include %{version}

* Wed Apr 05 2000 Nalin Dahyabhai <nalin@redhat.com>
- add man pages for kerberos(1), kvno(1), .k5login(5)
- add kvno to -workstation

* Mon Apr 03 2000 Nalin Dahyabhai <nalin@redhat.com>
- Merge krb5-configs back into krb5-libs.  The krb5.conf file is marked as
  a %%config file anyway.
- Make krb5.conf a noreplace config file.

* Thu Mar 30 2000 Nalin Dahyabhai <nalin@redhat.com>
- Make klogind pass a clean environment to children, like NetKit's rlogind does.

* Wed Mar 08 2000 Nalin Dahyabhai <nalin@redhat.com>
- Don't enable the server by default.
- Compress info pages.
- Add defaults for the PAM module to krb5.conf

* Mon Mar 06 2000 Nalin Dahyabhai <nalin@redhat.com>
- Correct copyright: it's exportable now, provided the proper paperwork is
  filed with the government.

* Fri Mar 03 2000 Nalin Dahyabhai <nalin@redhat.com>
- apply Mike Friedman's patch to fix format string problems
- don't strip off argv[0] when invoking regular rsh/rlogin

* Thu Mar 02 2000 Nalin Dahyabhai <nalin@redhat.com>
- run kadmin.local correctly at startup

* Mon Feb 28 2000 Nalin Dahyabhai <nalin@redhat.com>
- pass absolute path to kadm5.keytab if/when extracting keys at startup

* Sat Feb 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix info page insertions

* Wed Feb  9 2000 Nalin Dahyabhai <nalin@redhat.com>
- tweak server init script to automatically extract kadm5 keys if
  /var/kerberos/krb5kdc/kadm5.keytab doesn't exist yet
- adjust package descriptions

* Thu Feb  3 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix for potentially gzipped man pages

* Fri Jan 21 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix comments in krb5-configs

* Fri Jan  7 2000 Nalin Dahyabhai <nalin@redhat.com>
- move /usr/kerberos/bin to end of PATH

* Tue Dec 28 1999 Nalin Dahyabhai <nalin@redhat.com>
- install kadmin header files

* Tue Dec 21 1999 Nalin Dahyabhai <nalin@redhat.com>
- patch around TIOCGTLC defined on alpha and remove warnings from libpty.h
- add installation of info docs
- remove krb4 compat patch because it doesn't fix workstation-side servers

* Mon Dec 20 1999 Nalin Dahyabhai <nalin@redhat.com>
- remove hesiod dependency at build-time

* Sun Dec 19 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- rebuild on 1.1.1

* Thu Oct  7 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- clean up init script for server, verify that it works [jlkatz]
- clean up rotation script so that rc likes it better
- add clean stanza

* Mon Oct  4 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- backed out ncurses and makeshlib patches
- update for krb5-1.1
- add KDC rotation to rc.boot, based on ideas from Michael's C version

* Mon Sep 26 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- added -lncurses to telnet and telnetd makefiles

* Mon Jul  5 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- added krb5.csh and krb5.sh to /etc/profile.d

* Mon Jun 22 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- broke out configuration files

* Mon Jun 14 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- fixed server package so that it works now

* Sat May 15 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- started changelog
- updated existing 1.0.5 RPM from Eos Linux to krb5 1.0.6
- added --force to makeinfo commands to skip errors during build

%package configs
Summary: Kerberos 5 sample configuration file(s).
Group: System Environment/Base

%description configs
Kerberos is a trusted-third-party authentication system.  This package
contains sample configuration files for Kerberos 5 clients.

%package workstation
Summary: Kerberos 5 programs for use on workstations.
Group: System Environment/Base
Requires: %{name}-libs = %{version}
Prereq: grep, /sbin/install-info, /bin/sh, sh-utils

%description workstation
Kerberos is a trusted-third-party authentication system, named for the
three-headed watchdog from Greek mythology who guarded the entrance to
the underworld.  This package contains the basic Kerberos user programs
(kinit, klist, kdestroy, kpasswd) as well as kerberized versions of telnet,
ftp, rsh, and rlogin.

%package server
Group: System Environment/Daemons
Summary: Kerberos 5 server programs.
Requires: %{name}-libs = %{version}, %{name}-workstation = %{version}
Prereq: grep, /sbin/install-info, /bin/sh, sh-utils

%description server
Kerberos is a trusted-third-party authentication system, named for the
three-headed watchdog from Greek mythology who guarded the entrance to
the underworld.  This package contains the Kerberos 5 KDC and admin server
programs.  Most people should NOT install this package.

%package libs
Summary: Kerberos 5 shared libraries.
Group: System Environment/Libraries
Requires: %{name}-configs

%description libs
Kerberos is a trusted-third-party authentication system, named for the
three-headed watchdog from Greek mythology who guarded the entrance to
the underworld.  This package contains the Kerberos 5 shared libraries,
which are used by programs compiled with support for using Kerberos.
Most people should install this package.

%package devel
Summary: Files necessary for compiling Kerberos-aware programs.
Group: Development/Libraries
Requires: %{name}-libs = %{version}

%description devel
Kerberos is a trusted-third-party authentication system, named for the
three-headed watchdog from Greek mythology who guarded the entrance to
the underworld.  If you want to develop Kerberos-aware programs, then
you'll need to install this package.

%prep
%setup -q -b 1 -b 2
# %patch0
%patch1  -p0 -b .db
%patch2  -p0 -b .tciogltc
%patch3  -p0 -b .libpty
%patch4  -p0 -b .fixinfo
%patch5  -p0 -b .manpages
%patch6  -p0 -b .friedman
%patch7  -p0 -b .netkitr
%patch8  -p0 -b .rlogind
%patch9  -p1 -b .ksu
%patch10 -p1 -b .ksu
%patch11 -p1 -b .ksu
%patch12 -p1 -b .bufferparanoia
%patch13 -p1 -b .schiller
%patch14 -p1 -b .doublefree
%patch15 -p1 -b .schiller2
pushd src/include/kerberosIV
patch -l -p0 -b -z .raeburn < %{PATCH16}
popd
%patch17 -p1 -b .quiet
%patch18 -p1 -b .yu
%patch19 -p1 -b .brokenrev
%patch20 -p1 -b .gssftp
%patch21 -p1 -b .forward
%patch22 -p1 -b .heap
# clean out extra info files to keep them from being installed by mistake
find . -type f -name "*.fixinfo" -exec rm -fv "{}" ";"

%build
cd src

libtoolize --copy --force
cp config.{guess,sub} config

# Can't use %%configure because we don't use the default prefix.
CC="%{__cc} -ggdb" \
LDCOMBINE_TAIL="-lc" \
	./configure --prefix=%{prefix} \
	--enable-shared --enable-static \
	--with-tcl=%{_prefix} \
	--with-netlib=-lresolv \
	--localstatedir=%{_var}/kerberos \
	--infodir=%{_infodir} \
	--with-krb4 \
	%{_target_platform}
make

# Run the test suite.
# make check TMPDIR=%{_tmppath}

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

# Our shell scripts.
mkdir -p $RPM_BUILD_ROOT%{prefix}/bin
install -m 755 $RPM_SOURCE_DIR/{krsh,krlogin} $RPM_BUILD_ROOT/%{prefix}/bin/

# Extra headers.
mkdir -p $RPM_BUILD_ROOT%{prefix}/include
(cd src/include
 find kadm5 krb5 gssrpc gssapi -name "*.h" | \
 cpio -pdm  $RPM_BUILD_ROOT/%{prefix}/include )
sed 's^k5-int^krb5/kdb^g' < $RPM_BUILD_ROOT/%{prefix}/include/kadm5/admin.h \
			  > $RPM_BUILD_ROOT/%{prefix}/include/kadm5/admin.h2 &&\
mv $RPM_BUILD_ROOT/%{prefix}/include/kadm5/admin.h2 \
   $RPM_BUILD_ROOT/%{prefix}/include/kadm5/admin.h
find $RPM_BUILD_ROOT/%{prefix}/include -type d | xargs chmod 755
find $RPM_BUILD_ROOT/%{prefix}/include -type f | xargs chmod 644

# Info docs.
mkdir -p $RPM_BUILD_ROOT%{_infodir}
install -m 644 doc/*.info* $RPM_BUILD_ROOT%{_infodir}/
gzip $RPM_BUILD_ROOT%{_infodir}/*.info*

# KDC config files.
mkdir -p $RPM_BUILD_ROOT%{_var}/kerberos/krb5kdc
install -m 644 $RPM_SOURCE_DIR/kdc.conf  $RPM_BUILD_ROOT%{_var}/kerberos/krb5kdc/
install -m 644 $RPM_SOURCE_DIR/kadm5.acl $RPM_BUILD_ROOT%{_var}/kerberos/krb5kdc/

# Client config files and scripts.
mkdir -p $RPM_BUILD_ROOT/etc/profile.d
install -m 644 $RPM_SOURCE_DIR/krb5.conf $RPM_BUILD_ROOT/etc/krb5.conf
install -m 755 $RPM_SOURCE_DIR/krb5.{sh,csh} $RPM_BUILD_ROOT/etc/profile.d/

# KDC init script.
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 $RPM_SOURCE_DIR/krb5server.init $RPM_BUILD_ROOT/etc/rc.d/init.d/krb5server

# An init script to help balance out the loads on your KDCs.
install -m 755 $RPM_SOURCE_DIR/kdcrotate $RPM_BUILD_ROOT/etc/rc.d/init.d/

# The rest of the binaries and libraries and docs.
cd src
make prefix=$RPM_BUILD_ROOT%{prefix} \
	localstatedir=$RPM_BUILD_ROOT%{_var}/kerberos \
	infodir=$RPM_BUILD_ROOT%{_infodir} install

# Fixup strange shared library permissions.
chmod 755 $RPM_BUILD_ROOT%{prefix}/lib/*.so*

# Xinetd configuration files.
%if %{xinetd}
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d/
for xinetd in  %{SOURCE15} %{SOURCE16} %{SOURCE17} %{SOURCE18} %{SOURCE19} ; do
	install -m 644 $xinetd \
	$RPM_BUILD_ROOT/etc/xinetd.d/`basename $xinetd|sed 's/.xinetd$//'`
done
%endif

# Trim off useless info.
strip -g $RPM_BUILD_ROOT%{prefix}/{bin,sbin}/* $RPM_BUILD_ROOT%{prefix}/lib/lib* || :

%post libs
grep -q %{prefix}/lib /etc/ld.so.conf || echo %{prefix}/lib >> /etc/ld.so.conf
/sbin/ldconfig
#/sbin/chkconfig --add kdcrotate

#%preun libs
#if [ "$1" = "0" ] ; then
#	/sbin/chkconfig --del kdcrotate
#fi

%postun libs -p /sbin/ldconfig

%post server
/sbin/chkconfig --add krb5server
# Install info pages.
/sbin/install-info %{_infodir}/krb425.info.gz %{_infodir}/dir
/sbin/install-info %{_infodir}/krb5-admin.info.gz %{_infodir}/dir
/sbin/install-info %{_infodir}/krb5-install.info.gz %{_infodir}/dir

%preun server
if [ "$1" = "0" ] ; then
	/sbin/chkconfig --del krb5server
	/sbin/install-info --delete %{_infodir}/krb425.info.gz %{_infodir}/dir
	/sbin/install-info --delete %{_infodir}/krb5-admin.info.gz %{_infodir}/dir
	/sbin/install-info --delete %{_infodir}/krb5-install.info.gz %{_infodir}/dir
fi

%post workstation
/sbin/install-info %{_infodir}/krb5-user.info %{_infodir}/dir

%preun workstation
if [ "$1" = "0" ] ; then
	/sbin/install-info --delete %{_infodir}/krb5-user.info %{_infodir}/dir
fi

%files workstation
%defattr(-,root,root)
%config /etc/profile.d/krb5.sh
%config /etc/profile.d/krb5.csh
%if %{xinetd}
%config /etc/xinetd.d/*
%endif
%doc doc/user*.html doc/user*.ps src/config-files/services.append
%attr(0755,-,-) %doc src/config-files/convert-config-files
%{_infodir}/krb5-user.info*
%{prefix}/man/man1/kerberos.1*
%{prefix}/bin/kdestroy
%{prefix}/man/man1/kdestroy.1*
%{prefix}/bin/ftp
%{prefix}/man/man1/ftp.1*
%{prefix}/bin/kinit
%{prefix}/man/man1/kinit.1*
%{prefix}/bin/klist
%{prefix}/man/man1/klist.1*
%{prefix}/bin/kpasswd
%{prefix}/man/man1/kpasswd.1*
%{prefix}/sbin/kadmin
%{prefix}/man/man8/kadmin.8*
%{prefix}/sbin/ktutil
%{prefix}/man/man8/ktutil.8*
%{prefix}/bin/krb524init
%{prefix}/bin/gss-client
%attr(0755,root,root) %{prefix}/bin/ksu
%{prefix}/man/man1/ksu.1*
%{prefix}/bin/kvno
%{prefix}/man/man1/kvno.1*
%{prefix}/bin/rcp
%{prefix}/man/man1/rcp.1*
%{prefix}/bin/krlogin
%{prefix}/bin/rlogin
%{prefix}/man/man1/rlogin.1*
%{prefix}/bin/krsh
%{prefix}/bin/rsh
%{prefix}/man/man1/rsh.1*
%{prefix}/bin/telnet
%{prefix}/man/man1/telnet.1*
%attr(0755,root,root) %{prefix}/bin/v4rcp
%{prefix}/man/man1/v4rcp.1*
%{prefix}/bin/v5passwd
%{prefix}/man/man1/v5passwd.1*
%{prefix}/bin/sim_client
%{prefix}/bin/uuclient
%{prefix}/sbin/login.krb5
%{prefix}/man/man8/login.krb5.8*
%{prefix}/sbin/ftpd
%{prefix}/man/man8/ftpd.8*
%{prefix}/sbin/gss-server
%{prefix}/sbin/klogind
%{prefix}/man/man8/klogind.8*
%{prefix}/sbin/kshd
%{prefix}/man/man8/kshd.8*
%{prefix}/sbin/telnetd
%{prefix}/man/man8/telnetd.8*
%{prefix}/sbin/uuserver
%{prefix}/man/man5/krb5.conf.5*
%{prefix}/man/man5/.k5login.5*

%files server
%defattr(-,root,root)
%config /etc/rc.d/init.d/krb5server
%doc doc/admin*.ps doc/admin*.html doc/krb425*.html doc/krb425*.ps doc/install*.ps doc/install*.html
%dir %{_var}/kerberos/krb5kdc
%{_infodir}/krb5-admin.info*
%{_infodir}/krb5-install.info*
%{_infodir}/krb425.info*
%config(noreplace) %{_var}/kerberos/krb5kdc/kdc.conf
%config(noreplace) %{_var}/kerberos/krb5kdc/kadm5.acl
%{prefix}/man/man5/kdc.conf.5*
%{prefix}/sbin/kadmin.local
%{prefix}/man/man8/kadmin.local.8*
%{prefix}/sbin/kadmind
%{prefix}/man/man8/kadmind.8*
%{prefix}/sbin/kadmind4
%{prefix}/sbin/kdb5_util
%{prefix}/man/man8/kdb5_util.8*
%{prefix}/sbin/kprop
%{prefix}/man/man8/kprop.8*
%{prefix}/sbin/kpropd
%{prefix}/man/man8/kpropd.8*
%{prefix}/sbin/krb5-send-pr
%{prefix}/man/man1/krb5-send-pr.1*
%{prefix}/sbin/krb524d
%{prefix}/sbin/krb5kdc
%{prefix}/man/man8/krb5kdc.8*
%{prefix}/sbin/sim_server
%{prefix}/sbin/v5passwdd
# This is here for people who want to test their server, and also 
# included in devel package for similar reasons.
%{prefix}/bin/sclient
%{prefix}/man/man1/sclient.1*
%{prefix}/sbin/sserver
%{prefix}/man/man8/sserver.8*

%files libs
%defattr(-,root,root)
%{prefix}/lib/lib*.so.*

%files configs
%defattr(-,root,root)
%config /etc/rc.d/init.d/kdcrotate
%config(noreplace) /etc/krb5.conf

%files devel
%defattr(-,root,root)
%doc doc/api doc/implement doc/kadm5 doc/kadmin doc/krb5-protocol doc/rpc
%{prefix}/include
%{prefix}/lib/lib*.a
%{prefix}/lib/lib*.so
%{prefix}/bin/sclient
%{prefix}/man/man1/sclient.1*
%{prefix}/sbin/sserver
%{prefix}/man/man8/sserver.8*

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
